/* A number of encodings use the public use area to map to glyphs that are    */
/*  defined in planes other than the BMP (chinese), or just multiple encodings*/
/*  for the same glyph (ams)						      */

/* These data are taken from http://www.ams.org/STIX/bnb/stix-tbl.asc-2003-10-10 */
const int amspua[] = {
/* E000 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E008 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E010 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E018 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E020 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E028 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E030 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E038 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E040 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E048 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E050 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E058 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E060 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E068 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E070 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E078 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E080 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E088 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E090 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E098 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E100 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E108 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E110 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E118 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E120 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E128 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E130 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E138 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E140 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E148 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E150 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E158 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E160 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E168 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E170 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E178 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E180 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E188 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E190 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E198 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E1F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E200 */	0x027f8, 0x027f5, 0x027fa, 0x027f7, 0x027f9, 0x027f6, 0x0290e, 0x0290f,
/* E208 */	0x027fc, 0x02910, 0x02926, 0x02925, 0x02923, 0x02924, 0x02928, 0x02929,
/* E210 */	0x0292a, 0x02927, 0x02905,     0x0, 0x0297c, 0x0297d, 0x021f5, 0x0296f,
/* E218 */	0x0296e, 0x02937, 0x02936,     0x0, 0x02933,     0x0, 0x02945, 0x02946,
/* E220 */	0x0291f, 0x02920, 0x0291d, 0x0291e, 0x02964, 0x02962, 0x02963, 0x02965,
/* E228 */	0x0294b, 0x0294a, 0x02968, 0x02966, 0x02967, 0x02969, 0x0296a, 0x0296d,
/* E230 */	0x0296c, 0x0296b, 0x02192, 0x02190, 0x02972, 0x02975, 0x02971, 0x02949,
/* E238 */	0x02911, 0x02916, 0x0291a, 0x0291c, 0x02919, 0x0291b, 0x02938, 0x02939,
/* E240 */	0x02948, 0x021fe, 0x021fd, 0x021ff, 0x021dd, 0x02904, 0x02903, 0x02902,
/* E248 */	0x0237c, 0x0293c, 0x0293d, 0x0297e, 0x0297f, 0x02974, 0x02973, 0x02af0,
/* E250 */	0x02aef, 0x02a3f,     0x0,     0x0, 0x02a00, 0x02a01, 0x02a02, 0x02a06,
/* E258 */	0x02a04, 0x02a3c, 0x02a25, 0x02a2a, 0x02a2d, 0x02a2e, 0x02a34, 0x02a35,
/* E260 */	0x029b5, 0x02a40, 0x02abd, 0x02abe, 0x02a33, 0x02a5f, 0x02a22, 0x02a72,
/* E268 */	0x02a71, 0x02a27, 0x02a23, 0x02a24, 0x02a26, 0x02a30, 0x02a46, 0x02a47,
/* E270 */	0x02a48, 0x02a49, 0x02a4a, 0x02a4b,     0x0,     0x0,     0x0,     0x0,
/* E278 */	0x02a4c, 0x02a4d, 0x02a50, 0x02a39, 0x02a3a, 0x02a3b, 0x029cd, 0x029c4,
/* E280 */	0x029c5, 0x02a44, 0x02a45, 0x02a42, 0x02a43, 0x02a38, 0x029bc, 0x029bf,
/* E288 */	0x029c0, 0x029c1, 0x029b7, 0x029b9, 0x02a37, 0x02a36, 0x02a31,     0x0,
/* E290 */	    0x0, 0x02994, 0x02993, 0x023b1, 0x023b0, 0x02996, 0x02995, 0x02991,
/* E298 */	0x02992, 0x0298b, 0x0298c, 0x0298d, 0x0298e, 0x0298f, 0x02990, 0x02a8a,
/* E2A0 */	0x02a88, 0x02269, 0x02a89, 0x02a87, 0x02268, 0x02271, 0x02271, 0x02270,
/* E2A8 */	0x02270,     0x0, 0x02224, 0x02226, 0x02284, 0x02288, 0x02288, 0x02285,
/* E2B0 */	0x02289, 0x02289, 0x02ab9, 0x02ab5, 0x02aba, 0x02ab6, 0x02acb, 0x02acc,
/* E2B8 */	0x02acb, 0x0228a, 0x0228b, 0x02acc,     0x0,     0x0,     0x0,     0x0,
/* E2C0 */	    0x0, 0x02270, 0x02271, 0x0226e, 0x0226f,     0x0, 0x02249,     0x0,
/* E2C8 */	0x02af3, 0x0f423, 0x0f428,     0x0,     0x0,     0x0,     0x0, 0x022ed,
/* E2D0 */	0x022ec, 0x02aee,     0x0,     0x0,     0x0, 0x0210f, 0x029a4, 0x029a5,
/* E2D8 */	    0x0, 0x029a8, 0x029a9, 0x029aa, 0x029ab, 0x029ac, 0x029ad, 0x029ae,
/* E2E0 */	0x029af, 0x0299d, 0x025f9,     0x0, 0x025f8, 0x025fa, 0x029c9, 0x029b1,
/* E2E8 */	0x029b2, 0x029b3, 0x029b4, 0x0299a, 0x0ee39, 0x0204f, 0x023b5, 0x023b4,
/* E2F0 */	0x023b6, 0x029c2, 0x029c3,     0x0, 0x02a86, 0x02a8c, 0x02a7e, 0x02aa2,
/* E2F8 */	0x02a85, 0x02a8b, 0x02a7d, 0x02aa1,     0x0, 0x02ab7, 0x02aaf, 0x02ab8,
/* E300 */	0x02ab0, 0x02223, 0x02225, 0x02323, 0x02ac5, 0x02ac6, 0x02248,     0x0,
/* E308 */	    0x0, 0x02a77, 0x02adb, 0x02a9d, 0x02a9e, 0x02aeb, 0x02a74, 0x02ae4,
/* E310 */	0x02ae8, 0x02ae7, 0x02ae9, 0x02ae6, 0x02a6d, 0x02a70, 0x02aae, 0x02a73,
/* E318 */	0x02a78, 0x02a66, 0x02a29, 0x02ad9, 0x02ada, 0x02a7f, 0x02a80, 0x02a81,
/* E320 */	0x02a82, 0x02a83, 0x02a84, 0x02a97, 0x02a98, 0x02a79, 0x02a7a,     0x0,
/* E328 */	    0x0, 0x02a7b, 0x02a7c, 0x022da, 0x022db, 0x02a91, 0x02a92, 0x02aa4,
/* E330 */	0x02aa5, 0x02a93, 0x02a94, 0x02a8d, 0x02a8e, 0x02a8f, 0x02a90, 0x02a9f,
/* E338 */	0x02aa0, 0x02aaa, 0x02aab, 0x02aac, 0x02aad,     0x0,     0x0, 0x02979,
/* E340 */	0x0297b, 0x02abf, 0x02ac0, 0x02ac1, 0x02ac2, 0x02ac7, 0x02ac8, 0x02ad3,
/* E348 */	0x02ad4, 0x02ad5, 0x02ad6, 0x02ad7, 0x02ad8, 0x0ee40, 0x0ee41, 0x02ac3,
/* E350 */	0x02ac4, 0x02acf, 0x02ad0, 0x02ad1, 0x02ad2, 0x02aa6, 0x02aa7, 0x02aa8,
/* E358 */	0x02aa9, 0x029ce, 0x02ab3, 0x02ab4, 0x02abb, 0x02abc, 0x02976, 0x02978,
/* E360 */	    0x0, 0x02218,     0x0, 0x022a5, 0x1d453, 0x021d4,     0x0,     0x0,
/* E368 */	    0x0,     0x0, 0x0204e,     0x0, 0x0220c, 0x0220c, 0x02a55, 0x02a56,
/* E370 */	0x02209, 0x02057, 0x029dc, 0x0299c, 0x02a53, 0x02a54, 0x02a15, 0x02a16,
/* E378 */	0x02a0c,     0x0,     0x0, 0x022f7, 0x022f6, 0x022fe, 0x022fd, 0x001b5,
/* E380 */	0x0ee44, 0x0ee45, 0x02afd, 0x02af1, 0x029e3, 0x029e4, 0x029e5,     0x0,
/* E388 */	    0x0,     0x0,     0x0, 0x02a6a, 0x02a6f, 0x02af2, 0x029de, 0x029dd,
/* E390 */	    0x0, 0x02a5a, 0x02a5b, 0x02a5d, 0x02a5c, 0x02a10, 0x02a0d, 0x02a12,
/* E398 */	0x02a13, 0x02a14, 0x02a17, 0x02a11, 0x022f5,     0x0, 0x022f9,     0x0,
/* E3A0 */	0x022f2, 0x022fa, 0x022f3, 0x022fb, 0x022f4, 0x022fc, 0x0ee46, 0x0ee47,
/* E3A8 */	0x029bb, 0x02052, 0x029a6, 0x029a7, 0x02aec, 0x02aed, 0x02a57, 0x02a58,
/* E3B0 */	0x02a61, 0x02218, 0x0ee24,     0x0, 0x02026, 0x0ee30, 0x00308, 0x02aea,
/* E3B8 */	0x022f8,     0x0,     0x0,     0x0, 0x02209, 0x02275, 0x02274,     0x0,
/* E3C0 */	0x02053,     0x0,     0x0,     0x0, 0x02ae2,     0x0,     0x0, 0x0299f,
/* E3C8 */	0x029e1,     0x0, 0x02a51, 0x02a52, 0x003b1, 0x0026b,     0x0,     0x0,
/* E3D0 */	0x003c3, 0x00067, 0x025aa, 0x02a0f, 0x022bd, 0x0007c, 0x02934, 0x02935,
/* E3D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E3E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E3E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E3F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E3F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E400 */	    0x0,     0x0, 0x0290c,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E408 */	    0x0, 0x029be,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E410 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x02241,     0x0,     0x0,
/* E418 */	    0x0,     0x0, 0x029b0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E420 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E428 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E430 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E438 */	    0x0,     0x0,     0x0, 0x0ee3b, 0x0ee3c,     0x0,     0x0,     0x0,
/* E440 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E448 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E450 */	0x00308,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E458 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E460 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E468 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E470 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E478 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E480 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E488 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E490 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E498 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4F8 */	    0x0, 0x02423,     0x0,     0x0, 0x0ee31,     0x0,     0x0, 0x0ee32,
/* E500 */	0x1d538, 0x1d539, 0x02102, 0x1d53b, 0x1d53c, 0x1d53d, 0x1d53e, 0x0210d,
/* E508 */	0x1d540, 0x1d541, 0x1d542, 0x1d543, 0x1d544, 0x02115, 0x1d546, 0x02119,
/* E510 */	0x0211a, 0x0211d, 0x1d54a, 0x1d54b, 0x1d54c, 0x1d54d, 0x1d54e, 0x1d54f,
/* E518 */	0x1d550, 0x02124, 0x0213f,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E520 */	0x1d49c, 0x0212c, 0x1d49e, 0x1d49f, 0x02130, 0x02131, 0x1d4a2, 0x0210b,
/* E528 */	0x02110, 0x1d4a5, 0x1d4a6, 0x02112, 0x02133, 0x1d4a9, 0x1d4aa, 0x1d4ab,
/* E530 */	0x1d4ac, 0x0211b, 0x1d4ae, 0x1d4af, 0x1d4b0, 0x1d4b1, 0x1d4b2, 0x1d4b3,
/* E538 */	0x1d4b4, 0x1d4b5,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E540 */	0x1d4b6, 0x1d4b7, 0x1d4b8, 0x1d4b9, 0x0212f, 0x1d4bb, 0x0210a, 0x1d4bd,
/* E548 */	0x1d4be, 0x1d4bf, 0x1d4c0, 0x02113, 0x1d4c2, 0x1d4c3, 0x02134, 0x1d4c5,
/* E550 */	0x1d4c6, 0x1d4c7, 0x1d4c8, 0x1d4c9, 0x1d4ca, 0x1d4cb, 0x1d4cc, 0x1d4cd,
/* E558 */	0x1d4ce, 0x1d4cf,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E560 */	0x1d504, 0x1d505, 0x1d506, 0x1d507, 0x1d508, 0x1d509, 0x1d50a, 0x0210c,
/* E568 */	0x02111, 0x1d50d, 0x1d50e, 0x1d50f, 0x1d510, 0x1d511, 0x1d512, 0x1d513,
/* E570 */	0x1d514, 0x0211c, 0x1d516, 0x1d517, 0x1d518, 0x1d519, 0x1d51a, 0x1d51b,
/* E578 */	0x1d51c, 0x12128,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E580 */	0x1d51e, 0x1d51f, 0x1d520, 0x1d521, 0x1d522, 0x1d523, 0x1d524, 0x1d525,
/* E588 */	0x1d526, 0x1d527, 0x1d528, 0x1d529, 0x1d52a, 0x1d52b, 0x1d52c, 0x1d52d,
/* E590 */	0x1d52e, 0x1d52f, 0x1d530, 0x1d531, 0x1d532, 0x1d533, 0x1d534, 0x1d535,
/* E598 */	0x1d536, 0x1d537,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E5A0 */	0x02942, 0x02944, 0x02947, 0x02940, 0x02941,     0x0,     0x0,     0x0,
/* E5A8 */	0x02985,     0x0, 0x02980,     0x0, 0x0ec01,     0x0,     0x0, 0x02986,
/* E5B0 */	0x02af6,     0x0, 0x02999,     0x0, 0x0ee33, 0x0ee34, 0x0ee35, 0x0ee36,
/* E5B8 */	0x025a9, 0x0ee37, 0x0ee38,     0x0, 0x0ee80,     0x0,     0x0, 0x02222,
/* E5C0 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x02a08, 0x02a07, 0x02a63,
/* E5C8 */	0x02a5e,     0x0, 0x029ca,     0x0,     0x0,     0x0,     0x0, 0x02a95,
/* E5D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E5D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x02a96,
/* E5E0 */	    0x0,     0x0,     0x0,     0x0, 0x0e84e,     0x0,     0x0, 0x0ee50,
/* E5E8 */	0x0ee51, 0x0ee52, 0x0ee53,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E5F0 */	    0x0,     0x0, 0x0ee3a,     0x0, 0x0ee54,     0x0, 0x0ee55, 0x0ee56,
/* E5F8 */	0x0ee57, 0x0ee58,     0x0, 0x0ee59, 0x0ee5a, 0x0ee5b, 0x029f8, 0x029f9,
/* E600 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x0ee5c, 0x0ee5d, 0x0ee5e,
/* E608 */	0x0ee5f, 0x0ee60, 0x0ee61, 0x0ee62, 0x0224c, 0x0224c,     0x0, 0x029cb,
/* E610 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E618 */	    0x0, 0x02a2f,     0x0, 0x029b6,     0x0,     0x0,     0x0,     0x0,
/* E620 */	    0x0,     0x0,     0x0, 0x02205, 0x0ee10, 0x00326, 0x000b7,     0x0,
/* E628 */	    0x0, 0x003f5,     0x0,     0x0,     0x0, 0x0ee14, 0x00061,     0x0,
/* E630 */	0x0ee15,     0x0, 0x0ee18, 0x0ee19, 0x0ee1a, 0x0ee1b, 0x0ee1c,     0x0,
/* E638 */	0x0ee1d, 0x0ee1e, 0x0026e,     0x0, 0x002af,     0x0, 0x00235, 0x00236,
/* E640 */	0x0ee1f, 0x00221, 0x0ee12, 0x02afd, 0x0ee20,     0x0,     0x0, 0x02afb,
/* E648 */	    0x0,     0x0, 0x0005c, 0x0ee13, 0x0ee16,     0x0,     0x0,     0x0,
/* E650 */	0x021f9,     0x0,     0x0,     0x0, 0x0e215,     0x0,     0x0,     0x0,
/* E658 */	    0x0, 0x1d5b2,     0x0, 0x02a05,     0x0,     0x0,     0x0,     0x0,
/* E660 */	0x003d8, 0x003d9, 0x0223c, 0x003d2, 0x003f4,     0x0,     0x0,     0x0,
/* E668 */	0x00062, 0x00063, 0x00064, 0x00065, 0x00066, 0x00068, 0x00069, 0x0006a,
/* E670 */	0x0006b, 0x0006c, 0x0006d, 0x0006e, 0x0006f, 0x00070, 0x00071, 0x00072,
/* E678 */	0x00073, 0x00074, 0x00075, 0x00076, 0x00077, 0x00078, 0x00079, 0x0007a,
/* E680 */	0x0030f, 0x003c7, 0x003b2, 0x001a5, 0x01d1c, 0x01d07, 0x0004d, 0x0002f,
/* E688 */	0x01d00, 0x0029c, 0x0e2d4, 0x003b8, 0x003bb, 0x02260, 0x00110, 0x003c9,
/* E690 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E698 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6A0 */	0x0ee17, 0x0ee70, 0x0ee71,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E700 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E708 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E710 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E718 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E720 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E728 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E730 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E738 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E740 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E748 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E750 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E758 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E760 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E768 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E770 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E778 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E780 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E788 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E790 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E798 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E800 */	0x003f6, 0x0213f,     0x0, 0x1d7d9, 0x1d7d8, 0x02a03,     0x0,     0x0,
/* E808 */	    0x0, 0x02a09, 0x0290d, 0x029eb,     0x0, 0x029c6,     0x0,     0x0,
/* E810 */	0x029c7,     0x0, 0x02a32, 0x02ae3,     0x0,     0x0,     0x0,     0x0,
/* E818 */	    0x0, 0x029df, 0x02adc, 0x02add, 0x02141,     0x0,     0x0,     0x0,
/* E820 */	    0x0, 0x02a0e, 0x02a19, 0x02a1a, 0x02af4, 0x02a18,     0x0,     0x0,
/* E828 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x027fb, 0x027fd,     0x0,
/* E830 */	0x027fe,     0x0,     0x0,     0x0, 0x02906, 0x02907,     0x0,     0x0,
/* E838 */	    0x0, 0x029b8,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E840 */	0x02aa3,     0x0,     0x0, 0x02322, 0x02216,     0x0, 0x0214b, 0x0221d,
/* E848 */	    0x0, 0x00303,     0x0,     0x0,     0x0,     0x0, 0x0e84e,     0x0,
/* E850 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E858 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E860 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E868 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E870 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E878 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E880 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E888 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E890 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E898 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E8F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E900 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E908 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E910 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E918 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E920 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E928 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E930 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E938 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E940 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E948 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E950 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E958 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E960 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E968 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E970 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E978 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E980 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E988 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E990 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E998 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA00 */	0x029a2, 0x0299e, 0x029a3, 0x0ee73, 0x0ee74,     0x0, 0x0ee75, 0x02943,
/* EA08 */	0x02051, 0x00319, 0x0ee11,     0x0, 0x0ee76,     0x0,     0x0,     0x0,
/* EA10 */	    0x0, 0x029f3, 0x029f1,     0x0,     0x0, 0x029bd, 0x029ec, 0x029ed,
/* EA18 */	    0x0, 0x029ba, 0x02050, 0x0ee77, 0x029ef,     0x0,     0x0,     0x0,
/* EA20 */	    0x0,     0x0, 0x025a0,     0x0,     0x0, 0x0223c, 0x0ee21, 0x0ee22,
/* EA28 */	0x029ea, 0x02908, 0x0ee72,     0x0, 0x0ee78, 0x0ee79, 0x0ee7a, 0x0ee7b,
/* EA30 */	0x0ee7c, 0x0ee7d, 0x0ee23,     0x0,     0x0,     0x0,     0x0, 0x0ee7e,
/* EA38 */	    0x0,     0x0,     0x0,     0x0, 0x02142, 0x029e0, 0x0293e, 0x029d1,
/* EA40 */	0x029d4,     0x0,     0x0, 0x02983, 0x02922, 0x02921, 0x029f2, 0x029f0,
/* EA48 */	0x029ee,     0x0, 0x029d6, 0x02034, 0x021f6, 0x0293b, 0x029d2, 0x029d5,
/* EA50 */	0x02984, 0x02143, 0x1d5ab, 0x0ee42, 0x0ee43, 0x025fb, 0x025fc, 0x02a0b,
/* EA58 */	0x020e8, 0x0297a, 0x02a28, 0x029cc, 0x02909, 0x0ee7f, 0x02144, 0x029c8,
/* EA60 */	0x027d0, 0x029d3, 0x029d7, 0x00318, 0x02977, 0x02278, 0x02279,     0x0,
/* EA68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAA0 */	0x02987, 0x02988, 0x02989, 0x0298a, 0x02982, 0x02a3e, 0x02a1f, 0x02a20,
/* EAA8 */	0x02040, 0x02a21, 0x02a64, 0x02a65, 0x022ff, 0x02a41, 0x020e6,     0x0,
/* EAB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB00 */	0x0ee3d,     0x0, 0x0ee3e, 0x029e7, 0x0ee81, 0x029e8, 0x029e9,     0x0,
/* EB08 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EB98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EBF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC00 */	0x02a3d, 0x0e5ac, 0x0e5a5, 0x00302, 0x0030c, 0x00330, 0x020e7, 0x029e2,
/* EC08 */	0x0290a, 0x0290b, 0x02140, 0x02a1b, 0x02a1c, 0x02a1d, 0x02a1e,     0x0,
/* EC10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EC98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED00 */	0x0292b, 0x0292c, 0x0292d, 0x0292e, 0x0292f, 0x02930, 0x02931, 0x02932,
/* ED08 */	0x0294c, 0x0294d, 0x021f7, 0x021f8, 0x021fa,     0x0, 0x021fb, 0x021fc,
/* ED10 */	0x02900, 0x02901, 0x02914, 0x02915, 0x02917, 0x02918,     0x0,     0x0,
/* ED18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED20 */	0x0293f, 0x0293a,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED30 */	0x0e370, 0x0e36c,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED40 */	    0x0,     0x0, 0x02a2c, 0x02a2b, 0x02a62, 0x02a60,     0x0,     0x0,
/* ED48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED50 */	0x02a6b,     0x0,     0x0, 0x02a6c,     0x0,     0x0,     0x0,     0x0,
/* ED58 */	    0x0,     0x0, 0x02a67,     0x0,     0x0,     0x0, 0x02a76,     0x0,
/* ED60 */	0x02270, 0x02271,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED68 */	0x02a99, 0x02a9a, 0x02a9b, 0x02a9c,     0x0,     0x0,     0x0,     0x0,
/* ED70 */	0x02272, 0x02273, 0x02a9d, 0x02a9e, 0x02ab1, 0x02ab2,     0x0,     0x0,
/* ED78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED80 */	0x02ac9, 0x02aca, 0x02288, 0x02289, 0x02a59, 0x02a4e, 0x02a4f, 0x02acd,
/* ED88 */	0x02ace,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED90 */	0x02ae0, 0x02ade, 0x02adf, 0x02ae5, 0x02ae1, 0x0299b, 0x029a0, 0x029a1,
/* ED98 */	    0x0, 0x02af5, 0x02a68, 0x02a69, 0x02af7, 0x02af8, 0x02a0a, 0x0213e,
/* EDA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDF0 */	0x0ee82, 0x0ee83, 0x0ee84, 0x0220a, 0x0220d, 0x0ee85,     0x0,     0x0,
/* EDF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE00 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE08 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EED0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EED8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF00 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF08 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F000 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F008 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F010 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F018 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F020 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F028 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F030 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F038 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F040 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F048 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F050 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F058 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F060 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F068 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F070 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F078 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F080 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F088 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F090 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F098 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F100 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F108 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F110 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F118 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F120 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F128 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F130 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F138 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F140 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F148 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F150 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F158 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F160 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F168 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F170 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F178 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F180 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F188 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F190 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F198 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F200 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F208 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F210 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F218 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F220 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F228 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F230 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F238 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F240 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F248 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F250 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F258 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F260 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F268 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F270 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F278 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F280 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F288 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F290 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F298 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F300 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F308 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F310 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F318 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F320 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F328 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F330 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F338 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F340 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F348 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F350 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F358 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F360 */	    0x0,     0x0,     0x0,     0x0, 0x0205f,     0x0,     0x0,     0x0,
/* F368 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F370 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F378 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F380 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F388 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F390 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F398 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3B0 */	    0x0,     0x0, 0x0ee90,     0x0,     0x0,     0x0, 0x02062, 0x02061,
/* F3B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F400 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F408 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F410 */	0x029cf, 0x029d0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F418 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F420 */	    0x0,     0x0,     0x0, 0x0f423,     0x0,     0x0,     0x0,     0x0,
/* F428 */	0x0f428,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F430 */	    0x0, 0x02a75,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F438 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F440 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F448 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F450 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F458 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F460 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F468 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F470 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F478 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F480 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F488 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F490 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F498 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F4F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F500 */	    0x0,     0x0,     0x0, 0x02912, 0x02913, 0x0294e,     0x0, 0x02952,
/* F508 */	0x02953, 0x0295a, 0x0295b, 0x02950, 0x02956, 0x02957, 0x0295e, 0x0295f,
/* F510 */	0x0294f, 0x02954, 0x02955, 0x0295c, 0x0295d, 0x02951, 0x02958, 0x02959,
/* F518 */	0x02960, 0x02961,     0x0,     0x0,     0x0,     0x0,     0x0, 0x029f4,
/* F520 */	0x0ee05,     0x0,     0x0,     0x0, 0x02970,     0x0,     0x0, 0x0ee06,
/* F528 */	0x0ee07, 0x025fe, 0x02191, 0x02193,     0x0,     0x0,     0x0,     0x0,
/* F530 */	0x025fd,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F538 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F540 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F548 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F550 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F558 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F560 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F568 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F570 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F578 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F580 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F588 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F590 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F598 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F600 */	    0x0, 0x0ee91,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F608 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F610 */	    0x0,     0x0,     0x0,     0x0, 0x00346, 0x0033a,     0x0,     0x0,
/* F618 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F620 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F628 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F630 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F638 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F640 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F648 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F650 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F658 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F660 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F668 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F670 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F678 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F680 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F688 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F690 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F698 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x1d552, 0x1d553,
/* F6E8 */	0x1d554, 0x1d555, 0x1d556, 0x1d557, 0x1d558, 0x1d559, 0x1d55a, 0x1d55b,
/* F6F0 */	0x1d55c, 0x1d55d, 0x1d55e, 0x1d55f, 0x1d560, 0x1d561, 0x1d562, 0x1d563,
/* F6F8 */	0x1d564, 0x1d565, 0x1d566, 0x1d567, 0x1d568, 0x1d569, 0x1d56a, 0x1d56b,
/* F700 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F708 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F710 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F718 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F720 */	    0x0, 0x0ee92, 0x0ee93, 0x0ee94,     0x0, 0x026a0,     0x0,     0x0,
/* F728 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F730 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F738 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F740 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F748 */	    0x0, 0x0ee00, 0x0213d, 0x02145, 0x02146, 0x02147, 0x02148, 0x02149,
/* F750 */	0x02981, 0x0ee95, 0x0ee96, 0x0ee97,     0x0,     0x0, 0x0ee98, 0x0ee99,
/* F758 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F760 */	    0x0,     0x0,     0x0, 0x0ee9d, 0x0ee9a,     0x0, 0x0ee9e, 0x0ee9b,
/* F768 */	0x0ee9c, 0x0ee9f, 0x0eea0, 0x0eeab, 0x0eeac,     0x0,     0x0,     0x0,
/* F770 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F778 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F780 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F788 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F790 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F798 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x0eea1, 0x0eea2,
/* F7C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7D0 */	0x0eea3, 0x0eea4, 0x0eea5, 0x0eea6, 0x0eea7, 0x0eea8, 0x0eea9, 0x0eeaa,
/* F7D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F800 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F808 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F810 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F818 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F820 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F828 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F830 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F838 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F840 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F848 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F850 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F858 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F860 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F868 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F870 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F878 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F880 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F888 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F890 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F898 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0
};

/* These data are taken from adobe's cid2code.txt for ac14 */
const int cns14pua[] = {		/* Big5 and friends */
/* E000 */	0x20547,     0x0, 0x205df, 0x23fc5,     0x0,     0x0,     0x0,     0x0,
/* E008 */	    0x0, 0x24942, 0x289e4,     0x0, 0x219db,     0x0, 0x23cc8,     0x0,
/* E010 */	    0x0,     0x0, 0x24933, 0x289aa, 0x202a0, 0x26bb3, 0x21305,     0x0,
/* E018 */	0x224ed,     0x0, 0x26d29, 0x27a84, 0x23600, 0x24ab1, 0x22513,     0x0,
/* E020 */	0x2037e,     0x0, 0x20380, 0x20347,     0x0, 0x2041f,     0x0,     0x0,
/* E028 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x249a4, 0x20487,     0x0,
/* E030 */	0x233b4,     0x0, 0x20bff, 0x220fc, 0x202e5, 0x22530, 0x2058e, 0x23233,
/* E038 */	0x21983,     0x0,     0x0, 0x205b3, 0x23c99,     0x0,     0x0,     0x0,
/* E040 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x24aa6,     0x0,     0x0,
/* E048 */	    0x0,     0x0,     0x0,     0x0, 0x2372d,     0x0,     0x0,     0x0,
/* E050 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E058 */	    0x0,     0x0, 0x26b13,     0x0, 0x28ade,     0x0,     0x0, 0x23f80,
/* E060 */	0x20954, 0x23fec,     0x0,     0x0, 0x20be2,     0x0, 0x21726,     0x0,
/* E068 */	    0x0,     0x0,     0x0,     0x0, 0x216e8,     0x0,     0x0,     0x0,
/* E070 */	    0x0, 0x286ab,     0x0,     0x0, 0x21596, 0x21613,     0x0,     0x0,
/* E078 */	0x28a9b,     0x0,     0x0,     0x0,     0x0, 0x25772,     0x0,     0x0,
/* E080 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x20b8f,
/* E088 */	    0x0, 0x23feb, 0x22da3,     0x0, 0x20c77,     0x0,     0x0,     0x0,
/* E090 */	    0x0,     0x0,     0x0, 0x26b53, 0x20d74,     0x0,     0x0,     0x0,
/* E098 */	    0x0, 0x2170d, 0x20edd,     0x0, 0x20d4d, 0x289bc, 0x22698,     0x0,
/* E0A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x218d7, 0x2403a,
/* E0A8 */	    0x0, 0x24435,     0x0, 0x210b4,     0x0,     0x0, 0x2328a,     0x0,
/* E0B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0B8 */	    0x0,     0x0, 0x28b66,     0x0, 0x2124f,     0x0, 0x241a5,     0x0,
/* E0C0 */	    0x0,     0x0,     0x0, 0x26c7e,     0x0, 0x21416,     0x0, 0x21454,
/* E0C8 */	0x24363,     0x0, 0x24bf5,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0D0 */	0x2123c,     0x0,     0x0,     0x0, 0x2a150, 0x24278,     0x0,     0x0,
/* E0D8 */	    0x0,     0x0,     0x0,     0x0, 0x2163e,     0x0,     0x0, 0x21692,
/* E0E0 */	    0x0,     0x0, 0x20d4e, 0x26c81, 0x26d2a, 0x217dc,     0x0, 0x217fb,
/* E0E8 */	0x217b2, 0x26da6,     0x0, 0x21828, 0x216d5,     0x0, 0x26e45,     0x0,
/* E0F0 */	    0x0,     0x0, 0x249a9,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E0F8 */	0x26fa1, 0x22554,     0x0, 0x21911,     0x0, 0x216b8,     0x0,     0x0,
/* E100 */	    0x0,     0x0,     0x0, 0x27a0e,     0x0,     0x0, 0x20204,     0x0,
/* E108 */	    0x0, 0x21a34, 0x259cc, 0x205a5,     0x0,     0x0,     0x0,     0x0,
/* E110 */	0x21b44,     0x0,     0x0,     0x0, 0x21ca5, 0x26b28,     0x0,     0x0,
/* E118 */	    0x0,     0x0,     0x0,     0x0, 0x21df9, 0x21e37,     0x0,     0x0,
/* E120 */	    0x0, 0x21ea4,     0x0,     0x0,     0x0,     0x0, 0x24901, 0x22049,
/* E128 */	0x22173,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E130 */	0x244bc, 0x20cd3,     0x0,     0x0,     0x0,     0x0, 0x21771,     0x0,
/* E138 */	    0x0, 0x28482,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E140 */	    0x0, 0x201c1, 0x2f894,     0x0,     0x0, 0x2133a,     0x0, 0x26888,
/* E148 */	0x223d0,     0x0, 0x22471,     0x0,     0x0, 0x26e6e,     0x0,     0x0,
/* E150 */	0x28a36,     0x0,     0x0,     0x0, 0x25250, 0x21f6a, 0x270f8, 0x22668,
/* E158 */	    0x0, 0x2029e, 0x28a29,     0x0,     0x0, 0x21877,     0x0,     0x0,
/* E160 */	    0x0,     0x0, 0x227b4,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E168 */	0x24982, 0x2498f, 0x27a53,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E170 */	    0x0, 0x2f8a6, 0x26ed2,     0x0,     0x0, 0x20656,     0x0,     0x0,
/* E178 */	0x23fb7, 0x2285f,     0x0, 0x28b9d, 0x2995d,     0x0,     0x0, 0x22980,
/* E180 */	0x228c1,     0x0,     0x0,     0x0,     0x0, 0x20118,     0x0, 0x21770,
/* E188 */	    0x0, 0x22e0d,     0x0, 0x249df,     0x0,     0x0,     0x0, 0x2138e,
/* E190 */	0x217fc,     0x0,     0x0, 0x22e36,     0x0, 0x2408c, 0x2571d,     0x0,
/* E198 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x24a28,
/* E1A0 */	0x24a23,     0x0,     0x0,     0x0, 0x2307e,     0x0, 0x24940,     0x0,
/* E1A8 */	    0x0,     0x0, 0x21829,     0x0,     0x0,     0x0, 0x23400,     0x0,
/* E1B0 */	0x231f7, 0x231f8,     0x0, 0x231a4, 0x231a5,     0x0, 0x20e75,     0x0,
/* E1B8 */	0x251e6,     0x0,     0x0, 0x21e3d, 0x23231, 0x285f4, 0x231c8, 0x25313,
/* E1C0 */	    0x0, 0x228f7,     0x0,     0x0, 0x2439c, 0x24a21,     0x0,     0x0,
/* E1C8 */	0x237c2,     0x0,     0x0,     0x0, 0x241cd, 0x290ed,     0x0,     0x0,
/* E1D0 */	    0x0,     0x0,     0x0,     0x0, 0x233e6, 0x26da0,     0x0, 0x2346f,
/* E1D8 */	    0x0,     0x0, 0x28adf,     0x0,     0x0, 0x235cd,     0x0,     0x0,
/* E1E0 */	    0x0,     0x0, 0x2363c,     0x0,     0x0,     0x0, 0x28a4a,     0x0,
/* E1E8 */	    0x0,     0x0,     0x0, 0x203c9,     0x0,     0x0,     0x0, 0x23659,
/* E1F0 */	0x2212a,     0x0, 0x23703,     0x0,     0x0,     0x0,     0x0, 0x2919c,
/* E1F8 */	    0x0,     0x0, 0x20923,     0x0,     0x0,     0x0, 0x227cd,     0x0,
/* E200 */	0x23adb, 0x203b5, 0x21958,     0x0,     0x0, 0x23b5a,     0x0, 0x23efc,
/* E208 */	    0x0,     0x0, 0x2248b, 0x248f1, 0x26b51,     0x0,     0x0,     0x0,
/* E210 */	0x23dbc,     0x0, 0x23dbd, 0x241a4, 0x2490c, 0x24900, 0x23cc9,     0x0,
/* E218 */	    0x0, 0x20d32,     0x0, 0x231f9, 0x22491,     0x0,     0x0, 0x26d25,
/* E220 */	0x26da1, 0x26deb,     0x0,     0x0,     0x0,     0x0, 0x2497f, 0x24085,
/* E228 */	0x26e72,     0x0, 0x26f74,     0x0,     0x0,     0x0,     0x0, 0x28b21,
/* E230 */	    0x0, 0x23e2f,     0x0, 0x23f82,     0x0,     0x0,     0x0, 0x2304b,
/* E238 */	    0x0,     0x0,     0x0, 0x23e30,     0x0, 0x21497, 0x2403d,     0x0,
/* E240 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x29170,     0x0,     0x0,
/* E248 */	0x24144,     0x0, 0x24091, 0x24155, 0x24039, 0x23ff0, 0x23fb4, 0x2413f,
/* E250 */	    0x0, 0x24156, 0x24157, 0x24140, 0x261dd,     0x0,     0x0,     0x0,
/* E258 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E260 */	    0x0, 0x24277,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E268 */	0x24365,     0x0,     0x0, 0x242c1,     0x0, 0x2445a, 0x24a27, 0x24a22,
/* E270 */	    0x0, 0x28be8,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E278 */	    0x0,     0x0, 0x25605,     0x0,     0x0, 0x24974,     0x0,     0x0,
/* E280 */	    0x0,     0x0, 0x23044,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E288 */	0x24823, 0x2882b,     0x0, 0x28804,     0x0,     0x0,     0x0,     0x0,
/* E290 */	0x20c3a, 0x26a2e,     0x0,     0x0, 0x241e2, 0x216e7, 0x24a24,     0x0,
/* E298 */	    0x0, 0x249b7, 0x2498d, 0x249fb,     0x0,     0x0,     0x0, 0x24a26,
/* E2A0 */	    0x0, 0x205c3,     0x0,     0x0, 0x228ad,     0x0, 0x28eb2,     0x0,
/* E2A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E2B0 */	    0x0,     0x0, 0x24a8c, 0x2415f, 0x24a79, 0x28b8f,     0x0, 0x28c03,
/* E2B8 */	0x2189e,     0x0, 0x21988,     0x0,     0x0,     0x0, 0x28ed9, 0x21a4b,
/* E2C0 */	    0x0, 0x28eac,     0x0,     0x0,     0x0,     0x0,     0x0, 0x24f82,
/* E2C8 */	    0x0, 0x24d13,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E2D0 */	    0x0,     0x0,     0x0,     0x0, 0x263f5,     0x0,     0x0,     0x0,
/* E2D8 */	0x26911, 0x2690e,     0x0,     0x0,     0x0,     0x0, 0x26f9f,     0x0,
/* E2E0 */	0x2509d, 0x2517d, 0x21e1c,     0x0,     0x0,     0x0,     0x0, 0x25220,
/* E2E8 */	    0x0, 0x232ac,     0x0, 0x28964, 0x28968, 0x216c1,     0x0,     0x0,
/* E2F0 */	0x21376, 0x24a12,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E2F8 */	0x255e0,     0x0,     0x0,     0x0, 0x2760c,     0x0,     0x0, 0x28b2b,
/* E300 */	0x26083, 0x2261c,     0x0,     0x0,     0x0,     0x0, 0x25857,     0x0,
/* E308 */	0x27b39,     0x0,     0x0,     0x0, 0x27126,     0x0,     0x0, 0x2910d,
/* E310 */	    0x0, 0x23ed7,     0x0, 0x26ed3,     0x0, 0x257e0,     0x0,     0x0,
/* E318 */	0x28be9,     0x0,     0x0, 0x258e1, 0x294d9,     0x0,     0x0, 0x259ac,
/* E320 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x2648d,     0x0,     0x0,
/* E328 */	    0x0,     0x0,     0x0,     0x0, 0x25c01,     0x0,     0x0,     0x0,
/* E330 */	0x2530e, 0x25cfe,     0x0,     0x0,     0x0, 0x25bb4, 0x26c7f,     0x0,
/* E338 */	    0x0,     0x0,     0x0, 0x25d20,     0x0, 0x25c65,     0x0,     0x0,
/* E340 */	    0x0,     0x0, 0x25cc1,     0x0,     0x0, 0x24882,     0x0,     0x0,
/* E348 */	0x24578,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E350 */	    0x0,     0x0, 0x26e44,     0x0, 0x26ed6,     0x0,     0x0,     0x0,
/* E358 */	    0x0,     0x0,     0x0, 0x24057, 0x26029,     0x0,     0x0,     0x0,
/* E360 */	0x217f9,     0x0, 0x2836d,     0x0, 0x26121, 0x2615a,     0x0,     0x0,
/* E368 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x262d0,
/* E370 */	    0x0,     0x0, 0x26351,     0x0, 0x21661, 0x20068,     0x0, 0x23766,
/* E378 */	    0x0, 0x2833a,     0x0, 0x26489,     0x0,     0x0,     0x0,     0x0,
/* E380 */	    0x0, 0x2a087, 0x26cc3,     0x0,     0x0,     0x0, 0x22714,     0x0,
/* E388 */	0x26626, 0x23de3, 0x266e8,     0x0,     0x0, 0x28a48,     0x0,     0x0,
/* E390 */	    0x0, 0x226f6,     0x0, 0x26498, 0x24fb8,     0x0, 0x2148a,     0x0,
/* E398 */	0x2185e,     0x0, 0x24a65, 0x24a95,     0x0,     0x0, 0x20b0d, 0x26a52,
/* E3A0 */	0x23d7e,     0x0, 0x214fd,     0x0,     0x0, 0x26b0a, 0x249a7, 0x23530,
/* E3A8 */	0x21773, 0x23df8,     0x0,     0x0, 0x2f994,     0x0,     0x0,     0x0,
/* E3B0 */	    0x0, 0x20e16, 0x217b4,     0x0, 0x2317d, 0x2355a,     0x0,     0x0,
/* E3B8 */	    0x0, 0x23e8b, 0x26da3, 0x26b05, 0x26b97, 0x235ce,     0x0,     0x0,
/* E3C0 */	    0x0,     0x0,     0x0, 0x26da5,     0x0,     0x0,     0x0,     0x0,
/* E3C8 */	0x26ed4,     0x0,     0x0,     0x0, 0x26e42, 0x22eef,     0x0, 0x25be4,
/* E3D0 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x23cb5,     0x0,     0x0,
/* E3D8 */	0x26b96, 0x26e77, 0x26e43,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E3E0 */	    0x0, 0x25c91,     0x0, 0x25cc0,     0x0,     0x0,     0x0, 0x26e99,
/* E3E8 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x28625, 0x2863b,     0x0,
/* E3F0 */	0x27088,     0x0, 0x21582, 0x270cd, 0x2f9b2,     0x0,     0x0,     0x0,
/* E3F8 */	0x218a2,     0x0, 0x2739a,     0x0,     0x0, 0x2a0f8,     0x0, 0x22c27,
/* E400 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E408 */	    0x0, 0x275e0, 0x23db9, 0x275e4,     0x0,     0x0,     0x0,     0x0,
/* E410 */	    0x0,     0x0,     0x0,     0x0, 0x2770f,     0x0,     0x0,     0x0,
/* E418 */	    0x0,     0x0,     0x0, 0x28a25,     0x0, 0x27924, 0x27abd,     0x0,
/* E420 */	    0x0,     0x0,     0x0, 0x27a59,     0x0, 0x27b3a, 0x23f8f,     0x0,
/* E428 */	0x27b38,     0x0,     0x0,     0x0, 0x25430, 0x25565,     0x0,     0x0,
/* E430 */	    0x0,     0x0, 0x24a7a,     0x0,     0x0,     0x0, 0x216df,     0x0,
/* E438 */	    0x0,     0x0, 0x27d54, 0x27d8f, 0x2f9d4,     0x0, 0x27d53,     0x0,
/* E440 */	0x27d98, 0x27dbd,     0x0,     0x0, 0x21910,     0x0,     0x0,     0x0,
/* E448 */	0x24cc9,     0x0,     0x0,     0x0, 0x28002, 0x21014, 0x2498a,     0x0,
/* E450 */	0x281bc, 0x2710c,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E458 */	    0x0, 0x28365, 0x28412,     0x0,     0x0, 0x2a29f, 0x20a50,     0x0,
/* E460 */	    0x0, 0x289de, 0x2853d, 0x23dbb,     0x0, 0x23262,     0x0, 0x2a014,
/* E468 */	0x286bc, 0x28501, 0x22325,     0x0, 0x26ed7,     0x0, 0x2853c, 0x27abe,
/* E470 */	    0x0, 0x2856c, 0x2860b,     0x0, 0x28713,     0x0, 0x286e6,     0x0,
/* E478 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28933, 0x21e89,
/* E480 */	    0x0,     0x0,     0x0,     0x0, 0x255b9,     0x0, 0x28ac6, 0x23c9b,
/* E488 */	0x28b0c, 0x255db, 0x20d31,     0x0,     0x0, 0x28ae1, 0x28beb,     0x0,
/* E490 */	    0x0, 0x28ae2, 0x28ae5,     0x0,     0x0, 0x28bec, 0x28c39, 0x28bff,
/* E498 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4A0 */	    0x0, 0x2267a, 0x286d8, 0x2127c, 0x23e2e,     0x0,     0x0,     0x0,
/* E4A8 */	    0x0,     0x0,     0x0, 0x26ed5,     0x0,     0x0,     0x0, 0x28ae0,
/* E4B0 */	    0x0,     0x0,     0x0, 0x26cb8, 0x20274, 0x26410, 0x290af, 0x290e5,
/* E4B8 */	0x24ad1, 0x21915, 0x2330a,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E4C0 */	    0x0, 0x24ae9,     0x0,     0x0,     0x0,     0x0, 0x291d5,     0x0,
/* E4C8 */	    0x0, 0x291eb,     0x0,     0x0,     0x0, 0x230b7, 0x230bc,     0x0,
/* E4D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x2546c,     0x0,
/* E4D8 */	    0x0, 0x29433,     0x0,     0x0, 0x2941d, 0x2797a,     0x0,     0x0,
/* E4E0 */	    0x0,     0x0,     0x0,     0x0, 0x27175,     0x0, 0x20630, 0x2415c,
/* E4E8 */	0x25706,     0x0,     0x0,     0x0,     0x0,     0x0, 0x26d27, 0x216d3,
/* E4F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x24a29,     0x0,
/* E4F8 */	0x29857, 0x29905,     0x0,     0x0,     0x0,     0x0,     0x0, 0x25725,
/* E500 */	    0x0, 0x290b1, 0x29bd5,     0x0,     0x0, 0x29b05,     0x0,     0x0,
/* E508 */	    0x0,     0x0, 0x28600,     0x0,     0x0, 0x269a8,     0x0, 0x2307d,
/* E510 */	    0x0,     0x0, 0x29d3e,     0x0, 0x21863,     0x0, 0x2424b,     0x0,
/* E518 */	    0x0,     0x0, 0x29e68,     0x0, 0x29fb7, 0x2a192, 0x2a1ab, 0x2a0e1,
/* E520 */	0x2a123, 0x2a1df,     0x0,     0x0, 0x2a134,     0x0,     0x0,     0x0,
/* E528 */	0x2215b, 0x2a193, 0x2a220, 0x2193b, 0x2a233,     0x0, 0x2a0b9, 0x2a2b4,
/* E530 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x24364,
/* E538 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28c2b,     0x0,
/* E540 */	    0x0,     0x0,     0x0, 0x26da2,     0x0,     0x0,     0x0,     0x0,
/* E548 */	    0x0,     0x0,     0x0, 0x2908b,     0x0,     0x0,     0x0,     0x0,
/* E550 */	    0x0,     0x0,     0x0,     0x0, 0x24975, 0x249bb,     0x0, 0x249f8,
/* E558 */	0x24348, 0x24a51,     0x0, 0x28bda, 0x218fa,     0x0, 0x2897e, 0x28e36,
/* E560 */	    0x0,     0x0, 0x28a44,     0x0,     0x0,     0x0, 0x2896c, 0x244b9,
/* E568 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x24473, 0x243f8,     0x0,
/* E570 */	0x217ef,     0x0, 0x218be, 0x23599,     0x0, 0x21885, 0x2542f, 0x217f8,
/* E578 */	    0x0, 0x216fb, 0x21839,     0x0, 0x21774, 0x218d1, 0x25f4b,     0x0,
/* E580 */	0x216c0,     0x0, 0x24a25, 0x213fe, 0x212a8, 0x213c6, 0x214b6,     0x0,
/* E588 */	0x236a6,     0x0,     0x0, 0x24994, 0x27165, 0x23e31, 0x2555c, 0x23efb,
/* E590 */	0x27052,     0x0, 0x236ee, 0x2999d, 0x26f26,     0x0,     0x0,     0x0,
/* E598 */	    0x0,     0x0, 0x21922,     0x0,     0x0, 0x2373f, 0x240e1, 0x2408b,
/* E5A0 */	0x2410f, 0x26c21,     0x0,     0x0, 0x266b1,     0x0, 0x20fdf, 0x20ba8,
/* E5A8 */	0x20e0d,     0x0, 0x28b13,     0x0,     0x0,     0x0,     0x0, 0x24436,
/* E5B0 */	    0x0, 0x20465, 0x2037f,     0x0,     0x0, 0x25651,     0x0, 0x201ab,
/* E5B8 */	0x203cb,     0x0, 0x2030a, 0x20414,     0x0,     0x0, 0x202c0, 0x28eb3,
/* E5C0 */	0x20275,     0x0, 0x2020c,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E5C8 */	0x24a0e, 0x23e8a,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E5D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x23595,
/* E5D8 */	0x23e39, 0x23ebf,     0x0, 0x21884, 0x23e89,     0x0,     0x0, 0x205e0,
/* E5E0 */	    0x0, 0x204a3, 0x20492, 0x20491,     0x0, 0x28a9c, 0x2070e,     0x0,
/* E5E8 */	    0x0, 0x20873,     0x0,     0x0,     0x0,     0x0, 0x2438c, 0x20c20,
/* E5F0 */	0x249ac, 0x210e4,     0x0, 0x20e1d,     0x0,     0x0,     0x0,     0x0,
/* E5F8 */	    0x0,     0x0,     0x0, 0x24abc, 0x2408d,     0x0,     0x0,     0x0,
/* E600 */	0x240c9,     0x0, 0x20345,     0x0, 0x20bc6,     0x0,     0x0,     0x0,
/* E608 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28a46,
/* E610 */	0x216fa, 0x2176f, 0x21710,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E618 */	    0x0, 0x25946, 0x219f3, 0x21861, 0x24295,     0x0,     0x0,     0x0,
/* E620 */	    0x0, 0x25e83,     0x0, 0x28bd7, 0x20413,     0x0,     0x0, 0x21303,
/* E628 */	    0x0,     0x0,     0x0, 0x289fb,     0x0,     0x0,     0x0,     0x0,
/* E630 */	    0x0,     0x0, 0x21996, 0x2197c, 0x23aee,     0x0,     0x0, 0x21903,
/* E638 */	0x21904,     0x0, 0x218a0,     0x0, 0x216fe,     0x0,     0x0, 0x28a47,
/* E640 */	0x21dba, 0x23472, 0x289a8,     0x0,     0x0, 0x21927, 0x217ab,     0x0,
/* E648 */	0x2173b,     0x0,     0x0, 0x275fd,     0x0,     0x0, 0x22860, 0x2262b,
/* E650 */	    0x0,     0x0, 0x225af, 0x225be, 0x29088, 0x26f73,     0x0, 0x2003e,
/* E658 */	0x20046, 0x2261b,     0x0,     0x0,     0x0, 0x22c9b, 0x22d07, 0x246d4,
/* E660 */	0x2914d,     0x0, 0x24665, 0x22b6a,     0x0, 0x22b22, 0x23450, 0x298ea,
/* E668 */	0x22e78,     0x0, 0x2a45b,     0x0,     0x0,     0x0, 0x249e3, 0x22d67,
/* E670 */	    0x0, 0x22ca1,     0x0,     0x0,     0x0,     0x0, 0x2308e, 0x232ad,
/* E678 */	0x24989, 0x232ab,     0x0, 0x232e0, 0x218d9, 0x2943f,     0x0, 0x23289,
/* E680 */	0x231b3,     0x0,     0x0, 0x25584, 0x28b22, 0x2558f, 0x216fc, 0x2555b,
/* E688 */	0x25425,     0x0, 0x23103, 0x2182a, 0x23234,     0x0, 0x2320f, 0x23182,
/* E690 */	0x242c9,     0x0, 0x26d24,     0x0,     0x0,     0x0, 0x27870, 0x21deb,
/* E698 */	    0x0, 0x232d2, 0x232e1,     0x0, 0x25872,     0x0, 0x2383a, 0x237bc,
/* E6A0 */	    0x0, 0x237a2, 0x233fe,     0x0,     0x0,     0x0, 0x2462a,     0x0,
/* E6A8 */	    0x0,     0x0,     0x0,     0x0, 0x237d5, 0x24487,     0x0,     0x0,
/* E6B0 */	    0x0,     0x0, 0x21912,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6B8 */	    0x0, 0x23fc0, 0x23c9a,     0x0,     0x0, 0x28bea, 0x28acb,     0x0,
/* E6C0 */	0x2801e, 0x289dc,     0x0,     0x0,     0x0, 0x249ec,     0x0, 0x23f7f,
/* E6C8 */	    0x0,     0x0, 0x2403c,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E6D0 */	    0x0, 0x2431a, 0x24276,     0x0,     0x0,     0x0,     0x0, 0x2478f,
/* E6D8 */	0x24725,     0x0, 0x24aa4, 0x205eb,     0x0, 0x23ef8, 0x2365f, 0x24a4a,
/* E6E0 */	0x24917, 0x25fe1,     0x0,     0x0, 0x24adf, 0x28c23, 0x23f35,     0x0,
/* E6E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x26dea,     0x0,
/* E6F0 */	    0x0,     0x0, 0x24cd9, 0x24d06,     0x0,     0x0,     0x0, 0x2a5c6,
/* E6F8 */	    0x0,     0x0, 0x28acc, 0x249ab, 0x2498e,     0x0,     0x0, 0x24a4e,
/* E700 */	    0x0, 0x249c5, 0x248f3,     0x0,     0x0,     0x0, 0x28ae3, 0x21864,
/* E708 */	    0x0, 0x25221, 0x251e7,     0x0, 0x23232,     0x0,     0x0,     0x0,
/* E710 */	0x24697, 0x23781,     0x0, 0x248f0,     0x0,     0x0,     0x0, 0x24aba,
/* E718 */	0x24ac7,     0x0, 0x24a96, 0x261ae,     0x0, 0x25581,     0x0,     0x0,
/* E720 */	    0x0,     0x0,     0x0,     0x0, 0x27741, 0x256e3,     0x0,     0x0,
/* E728 */	    0x0,     0x0,     0x0, 0x23efa,     0x0,     0x0,     0x0, 0x216e6,
/* E730 */	    0x0,     0x0,     0x0, 0x20d4c, 0x2498c, 0x20299, 0x23dba, 0x2176e,
/* E738 */	    0x0,     0x0,     0x0,     0x0, 0x201d4, 0x20c0d,     0x0,     0x0,
/* E740 */	0x226f5, 0x25aaf, 0x25a9c,     0x0, 0x2025b,     0x0,     0x0, 0x25bc6,
/* E748 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x25bb3, 0x25ebc, 0x25ea6,
/* E750 */	    0x0, 0x249f9, 0x217b0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E758 */	    0x0,     0x0,     0x0, 0x26261, 0x2615c, 0x27b48,     0x0, 0x25e82,
/* E760 */	    0x0, 0x26b75, 0x20916,     0x0, 0x2004e, 0x235cf,     0x0, 0x26412,
/* E768 */	0x263f8, 0x24962,     0x0,     0x0, 0x2082c, 0x25ae9, 0x25d43,     0x0,
/* E770 */	0x25e0e,     0x0,     0x0,     0x0,     0x0, 0x2343f,     0x0, 0x249f7,
/* E778 */	0x265ad,     0x0, 0x265a0,     0x0, 0x27127, 0x26cd1,     0x0,     0x0,
/* E780 */	    0x0,     0x0,     0x0,     0x0, 0x267b4,     0x0, 0x26a42,     0x0,
/* E788 */	    0x0, 0x26a51,     0x0, 0x26da7,     0x0, 0x2721b,     0x0,     0x0,
/* E790 */	0x21840,     0x0, 0x218a1,     0x0, 0x218d8,     0x0, 0x2f9bc, 0x23d8f,
/* E798 */	    0x0, 0x27422,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7A0 */	    0x0,     0x0, 0x25683,     0x0, 0x27785, 0x27784, 0x28bf5, 0x28bd9,
/* E7A8 */	0x28b9c, 0x289f9,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7B0 */	    0x0, 0x29448,     0x0,     0x0, 0x24284,     0x0,     0x0,     0x0,
/* E7B8 */	0x21845,     0x0,     0x0,     0x0, 0x27ddc,     0x0,     0x0,     0x0,
/* E7C0 */	    0x0,     0x0,     0x0,     0x0, 0x24c09,     0x0,     0x0,     0x0,
/* E7C8 */	    0x0,     0x0, 0x22321,     0x0,     0x0,     0x0, 0x217da,     0x0,
/* E7D0 */	    0x0, 0x2492f,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E7D8 */	0x28a4b,     0x0, 0x28afc,     0x0, 0x28c1d, 0x28c3b,     0x0,     0x0,
/* E7E0 */	    0x0,     0x0,     0x0,     0x0, 0x28d34,     0x0,     0x0, 0x248ff,
/* E7E8 */	0x24a42, 0x243ea,     0x0, 0x23225,     0x0, 0x28ee7, 0x28e66, 0x28e65,
/* E7F0 */	    0x0, 0x249ed, 0x24a78, 0x23fee,     0x0,     0x0,     0x0,     0x0,
/* E7F8 */	0x290b0,     0x0,     0x0, 0x29093, 0x257df,     0x0,     0x0, 0x28989,
/* E800 */	0x28c26, 0x28b2f, 0x263be,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E808 */	0x2421b,     0x0,     0x0,     0x0, 0x20f26,     0x0, 0x28bc5, 0x24ab2,
/* E810 */	    0x0, 0x294da,     0x0, 0x295d7,     0x0,     0x0, 0x28b50, 0x24a67,
/* E818 */	0x28b64,     0x0, 0x28a45,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E820 */	    0x0, 0x27b06,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28b65,
/* E828 */	0x258c8,     0x0,     0x0,     0x0,     0x0, 0x298f1,     0x0, 0x29948,
/* E830 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x21302,     0x0, 0x249b8,
/* E838 */	0x214e8,     0x0, 0x2271f, 0x23db8,     0x0,     0x0,     0x0,     0x0,
/* E840 */	    0x0, 0x22781, 0x2296b,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E848 */	    0x0,     0x0,     0x0, 0x29e2d,     0x0, 0x2a1f5, 0x2a0fe,     0x0,
/* E850 */	    0x0, 0x24104,     0x0,     0x0,     0x0, 0x2a1b4, 0x2a0ed, 0x2a0f3,
/* E858 */	0x2992f,     0x0,     0x0, 0x26e12, 0x26fdf, 0x26b82,     0x0,     0x0,
/* E860 */	0x26da4, 0x26e84, 0x26df0,     0x0,     0x0, 0x26e00, 0x237d7, 0x26064,
/* E868 */	    0x0, 0x2359c, 0x23640,     0x0, 0x249de,     0x0,     0x0,     0x0,
/* E870 */	    0x0, 0x202bf,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E878 */	0x2555d,     0x0,     0x0,     0x0,     0x0, 0x21757, 0x231c9, 0x24941,
/* E880 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x241b5,
/* E888 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x241ac,
/* E890 */	    0x0, 0x26c40, 0x24f97,     0x0, 0x217b5, 0x28a49,     0x0,     0x0,
/* E898 */	    0x0,     0x0, 0x24488,     0x0,     0x0, 0x289fc,     0x0,     0x0,
/* E8A0 */	0x218d6, 0x20f1d,     0x0, 0x26cc0, 0x21413, 0x242fa, 0x22c26, 0x243c1,
/* E8A8 */	    0x0, 0x23db7, 0x26741,     0x0, 0x2615b, 0x260a4, 0x249b9, 0x2498b,
/* E8B0 */	0x289fa,     0x0,     0x0,     0x0,     0x0, 0x28b63, 0x2189f,     0x0,
/* E8B8 */	0x24ab3,     0x0,     0x0,     0x0,     0x0, 0x24a3e, 0x24a94, 0x217d9,
/* E8C0 */	0x24a66, 0x203a7, 0x21424, 0x249e5,     0x0, 0x24916,     0x0, 0x24976,
/* E8C8 */	    0x0,     0x0,     0x0, 0x204fe,     0x0, 0x28ace, 0x28a16,     0x0,
/* E8D0 */	0x28be7, 0x255d5,     0x0, 0x28a82,     0x0, 0x24943, 0x20cff,     0x0,
/* E8D8 */	0x2061a, 0x20beb, 0x20cb8,     0x0,     0x0, 0x217fa,     0x0, 0x216c2,
/* E8E0 */	0x24a50, 0x21852,     0x0,     0x0,     0x0, 0x28ac0, 0x249ad,     0x0,
/* E8E8 */	0x218bf, 0x21883, 0x27484,     0x0,     0x0, 0x23d5b,     0x0,     0x0,
/* E8F0 */	    0x0, 0x28a81, 0x21862,     0x0,     0x0, 0x20ab4,     0x0,     0x0,
/* E8F8 */	    0x0,     0x0,     0x0, 0x2139c,     0x0,     0x0, 0x28218,     0x0,
/* E900 */	0x290e4,     0x0,     0x0, 0x27e4f,     0x0,     0x0,     0x0, 0x23fed,
/* E908 */	0x23e2d,     0x0,     0x0,     0x0, 0x203f5,     0x0,     0x0,     0x0,
/* E910 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28c1c,
/* E918 */	0x26bc0,     0x0,     0x0,     0x0, 0x21452,     0x0, 0x24362, 0x24a71,
/* E920 */	0x22fe3, 0x212b0, 0x223bd,     0x0,     0x0, 0x21398, 0x234e5, 0x27bf4,
/* E928 */	0x236df, 0x28a83, 0x237d6, 0x233fa, 0x24c9f,     0x0, 0x236ad, 0x26cb7,
/* E930 */	    0x0,     0x0,     0x0, 0x26d26, 0x26d51, 0x26c82, 0x26fde,     0x0,
/* E938 */	0x27109,     0x0, 0x2173a,     0x0, 0x26c80, 0x27053, 0x217db,     0x0,
/* E940 */	    0x0, 0x217b3,     0x0,     0x0, 0x21905, 0x241fc,     0x0,     0x0,
/* E948 */	0x2173c,     0x0,     0x0,     0x0,     0x0, 0x242a5,     0x0,     0x0,
/* E950 */	0x24293,     0x0, 0x23ef9, 0x27736, 0x2445b, 0x242ca,     0x0, 0x24259,
/* E958 */	0x289e1,     0x0, 0x26d28,     0x0, 0x244ce, 0x27e4d, 0x243bd,     0x0,
/* E960 */	0x24256, 0x21304,     0x0,     0x0, 0x243e9,     0x0,     0x0, 0x2f825,
/* E968 */	0x24a4f,     0x0,     0x0,     0x0,     0x0,     0x0, 0x24a5d, 0x217df,
/* E970 */	    0x0,     0x0,     0x0, 0x23afa, 0x23300, 0x20214,     0x0, 0x208d5,
/* E978 */	0x20619,     0x0, 0x21f9e, 0x2a2b6,     0x0, 0x2915b,     0x0,     0x0,
/* E980 */	    0x0, 0x28a59, 0x29420,     0x0,     0x0,     0x0,     0x0, 0x27af4,
/* E988 */	    0x0,     0x0, 0x256f6,     0x0,     0x0,     0x0, 0x27b18,     0x0,
/* E990 */	    0x0, 0x248f2,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E998 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9B0 */	0x24f5c,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9C8 */	    0x0,     0x0,     0x0, 0x25535,     0x0,     0x0,     0x0,     0x0,
/* E9D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x20ccf,
/* E9F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* E9F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA00 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA08 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA40 */	    0x0,     0x0,     0x0, 0x27967,     0x0,     0x0,     0x0,     0x0,
/* EA48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EA98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAA8 */	    0x0, 0x21bc2,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EAB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x20094,
/* EAC0 */	0x202b7, 0x203a0,     0x0,     0x0,     0x0, 0x204d7,     0x0,     0x0,
/* EAC8 */	    0x0, 0x205d5, 0x20615, 0x20676, 0x216ba,     0x0,     0x0, 0x20ac2,
/* EAD0 */	0x20acd, 0x20bbf,     0x0, 0x2f83b, 0x20bcb,     0x0, 0x20bfb, 0x20c3b,
/* EAD8 */	0x20c53, 0x20c65, 0x20c7c,     0x0, 0x20c8d,     0x0, 0x20cb5, 0x20cdd,
/* EAE0 */	0x20ced, 0x20d6f, 0x20db2, 0x20dc8,     0x0,     0x0,     0x0, 0x20e04,
/* EAE8 */	0x20e0e, 0x20ed7, 0x20f90, 0x20f2d, 0x20e73,     0x0, 0x20fbc,     0x0,
/* EAF0 */	0x2105c, 0x2104f, 0x21076,     0x0, 0x2107b, 0x21088, 0x21096,     0x0,
/* EAF8 */	0x210bf, 0x210d3, 0x2112f, 0x2113b,     0x0,     0x0, 0x212e3, 0x21375,
/* EB00 */	0x21336,     0x0, 0x21577, 0x21619, 0x217c3, 0x217c7,     0x0,     0x0,
/* EB08 */	0x2182d, 0x2196a, 0x21a2d, 0x21a45, 0x21c2a, 0x21c70, 0x21cac, 0x21ec8,
/* EB10 */	    0x0, 0x21ed5, 0x21f15,     0x0,     0x0, 0x22045,     0x0,     0x0,
/* EB18 */	0x2227c, 0x223d7, 0x223fa, 0x2272a, 0x22871, 0x2294f,     0x0, 0x22967,
/* EB20 */	0x22993, 0x22ad5,     0x0, 0x22ae8,     0x0, 0x22b0e,     0x0, 0x22b3f,
/* EB28 */	    0x0,     0x0, 0x22c4c,     0x0, 0x22c88, 0x22cb7, 0x25be8, 0x22d08,
/* EB30 */	0x22d12, 0x22db7, 0x22d95, 0x22e42, 0x22f74, 0x22fcc, 0x23033, 0x23066,
/* EB38 */	0x2331f, 0x233de,     0x0,     0x0,     0x0, 0x27a79, 0x23567, 0x235f3,
/* EB40 */	    0x0, 0x249ba,     0x0, 0x2361a, 0x23716,     0x0, 0x20346,     0x0,
/* EB48 */	    0x0,     0x0, 0x23aa7, 0x27657, 0x25fe2, 0x23e11, 0x23eb9, 0x275fe,
/* EB50 */	0x2209a,     0x0,     0x0, 0x24119, 0x28a9a, 0x242ee, 0x2430d, 0x2403b,
/* EB58 */	0x24334, 0x24396, 0x24a45, 0x205ca,     0x0, 0x20611,     0x0, 0x21ea8,
/* EB60 */	    0x0, 0x23cff, 0x24404, 0x244d6,     0x0, 0x24674,     0x0, 0x2472f,
/* EB68 */	0x285e8, 0x299c9,     0x0, 0x221c3,     0x0, 0x28b4e,     0x0, 0x24812,
/* EB70 */	0x248fb, 0x24a15,     0x0, 0x24ac0, 0x20c78,     0x0, 0x24ea5, 0x24f86,
/* EB78 */	0x20779,     0x0, 0x2502c,     0x0,     0x0,     0x0, 0x25299, 0x25419,
/* EB80 */	0x23f4a, 0x24aa7,     0x0, 0x25446, 0x2546e, 0x26b52,     0x0,     0x0,
/* EB88 */	0x2553f, 0x27632, 0x2555e,     0x0, 0x25562, 0x25566, 0x257c7, 0x2493f,
/* EB90 */	0x2585d,     0x0,     0x0, 0x233cc,     0x0, 0x25903,     0x0, 0x28948,
/* EB98 */	0x25aae, 0x25b89, 0x25c06, 0x21d90,     0x0,     0x0,     0x0, 0x26102,
/* EBA0 */	0x27c12,     0x0, 0x261b2, 0x24f9a,     0x0, 0x26402, 0x2644a,     0x0,
/* EBA8 */	0x26bf7,     0x0, 0x26484, 0x2191c,     0x0, 0x249f6, 0x26488, 0x23fef,
/* EBB0 */	0x26512,     0x0, 0x265bf, 0x266b5, 0x2271b,     0x0, 0x257e1,     0x0,
/* EBB8 */	    0x0, 0x2f8cd,     0x0,     0x0, 0x24521, 0x266fc,     0x0, 0x24934,
/* EBC0 */	    0x0,     0x0, 0x26cbd,     0x0,     0x0, 0x26799, 0x2686e, 0x26411,
/* EBC8 */	0x2685e,     0x0, 0x268c7,     0x0, 0x290c0, 0x20a11, 0x26926,     0x0,
/* EBD0 */	0x26939,     0x0,     0x0, 0x269fa,     0x0, 0x26a2d,     0x0, 0x26469,
/* EBD8 */	0x20021,     0x0, 0x26a34, 0x26b5b,     0x0, 0x23519,     0x0, 0x26b9d,
/* EBE0 */	    0x0, 0x26ca4,     0x0,     0x0, 0x26dae,     0x0,     0x0, 0x2258d,
/* EBE8 */	0x2704b, 0x271cd,     0x0, 0x27280, 0x27285,     0x0, 0x2217a, 0x2728b,
/* EBF0 */	    0x0, 0x272e6, 0x249d0,     0x0,     0x0, 0x27450, 0x20ef8,     0x0,
/* EBF8 */	    0x0, 0x22926, 0x28473, 0x217b1,     0x0, 0x24a2a, 0x21820,     0x0,
/* EC00 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x29cad, 0x298a4,     0x0,
/* EC08 */	0x277cc, 0x27858,     0x0,     0x0, 0x2160a,     0x0, 0x2372f, 0x280e8,
/* EC10 */	0x213c5,     0x0,     0x0, 0x279dd, 0x291a8,     0x0,     0x0, 0x270af,
/* EC18 */	0x289ab, 0x279fd, 0x27a0a, 0x27b0b, 0x27d66, 0x2417a,     0x0,     0x0,
/* EC20 */	0x28009,     0x0, 0x2a2df,     0x0, 0x28318,     0x0, 0x26e07,     0x0,
/* EC28 */	    0x0,     0x0, 0x2816f, 0x28023, 0x269b5, 0x213ed, 0x2322f, 0x28048,
/* EC30 */	    0x0, 0x28c30, 0x28083,     0x0,     0x0, 0x28949,     0x0, 0x24988,
/* EC38 */	    0x0,     0x0,     0x0, 0x24aa5, 0x23f81,     0x0,     0x0, 0x28090,
/* EC40 */	0x280f4, 0x2812e, 0x21fa1, 0x2814f, 0x28189, 0x281af, 0x2821a, 0x28306,
/* EC48 */	0x2832f, 0x2838a,     0x0, 0x28468, 0x286aa,     0x0,     0x0, 0x28956,
/* EC50 */	    0x0,     0x0, 0x289b8,     0x0, 0x289e7,     0x0, 0x289e8, 0x28b46,
/* EC58 */	0x28bd4,     0x0, 0x28c09,     0x0, 0x28fc5, 0x290ec,     0x0, 0x29110,
/* EC60 */	0x2913c,     0x0, 0x2915e, 0x24aca,     0x0,     0x0,     0x0, 0x294e7,
/* EC68 */	0x295e9, 0x295b0, 0x295b8, 0x29732, 0x298d1, 0x29949, 0x2996a, 0x299c3,
/* EC70 */	0x29a28, 0x29b0e, 0x29d5a, 0x29d9b,     0x0, 0x29ef8, 0x29f23,     0x0,
/* EC78 */	    0x0, 0x2a293,     0x0, 0x2a2ff,     0x0,     0x0, 0x2a5cb,     0x0,
/* EC80 */	0x20c9c,     0x0,     0x0,     0x0, 0x224b0,     0x0, 0x24a93,     0x0,
/* EC88 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x28b2c, 0x2789d,     0x0,
/* EC90 */	    0x0, 0x217f5, 0x28024, 0x28b6c, 0x28b99, 0x27a3e, 0x266af,     0x0,
/* EC98 */	0x27655, 0x23cb7, 0x25635, 0x25956,     0x0, 0x25e81, 0x26258,     0x0,
/* ECA0 */	0x20e6d,     0x0,     0x0, 0x23e88, 0x24c9e,     0x0,     0x0, 0x217f6,
/* ECA8 */	0x2187b,     0x0,     0x0, 0x25c4a,     0x0, 0x25311,     0x0, 0x29d98,
/* ECB0 */	    0x0,     0x0,     0x0,     0x0, 0x25ed8,     0x0, 0x23d40,     0x0,
/* ECB8 */	    0x0, 0x20fea, 0x20d49, 0x236ba,     0x0,     0x0,     0x0,     0x0,
/* ECC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x20e9d,
/* ECD0 */	    0x0,     0x0,     0x0,     0x0, 0x282e2,     0x0,     0x0,     0x0,
/* ECD8 */	    0x0,     0x0,     0x0, 0x20c41, 0x20c96,     0x0, 0x25148, 0x20e76,
/* ECE0 */	0x22c62, 0x20ea2,     0x0,     0x0,     0x0, 0x21075,     0x0,     0x0,
/* ECE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ECF0 */	0x22b43,     0x0, 0x22eb3,     0x0,     0x0, 0x20da7,     0x0,     0x0,
/* ECF8 */	    0x0,     0x0,     0x0,     0x0, 0x2688a,     0x0,     0x0,     0x0,
/* ED00 */	    0x0,     0x0,     0x0,     0x0, 0x210c1,     0x0,     0x0, 0x24706,
/* ED08 */	    0x0,     0x0, 0x26893,     0x0, 0x226f4, 0x27d2f, 0x241a3, 0x27d73,
/* ED10 */	0x26ed0, 0x272b6,     0x0, 0x211d9,     0x0, 0x23cfc, 0x2a6a9, 0x20eac,
/* ED18 */	0x20ef9,     0x0, 0x21ca2,     0x0, 0x24fc2, 0x27ff9, 0x20feb,     0x0,
/* ED20 */	    0x0,     0x0, 0x22da0,     0x0, 0x247e0, 0x29d7c, 0x20fec, 0x20e0a,
/* ED28 */	    0x0, 0x275a3, 0x20fed,     0x0, 0x26048, 0x21187,     0x0,     0x0,
/* ED30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED38 */	    0x0,     0x0,     0x0, 0x24618,     0x0, 0x24b6e,     0x0,     0x0,
/* ED40 */	    0x0, 0x25a95, 0x20979,     0x0,     0x0, 0x22465,     0x0, 0x29eac,
/* ED48 */	    0x0,     0x0, 0x23cfe, 0x29f30,     0x0, 0x24fa9, 0x2959e, 0x29fde,
/* ED50 */	    0x0, 0x23db6, 0x272b2, 0x267b3, 0x23720,     0x0,     0x0, 0x23ef7,
/* ED58 */	0x23e2c,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x2048e,
/* ED60 */	    0x0,     0x0, 0x20eb6,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED68 */	    0x0,     0x0,     0x0, 0x2a434,     0x0,     0x0,     0x0,     0x0,
/* ED70 */	    0x0, 0x230da, 0x243f2,     0x0,     0x0, 0x212a9,     0x0, 0x24963,
/* ED78 */	0x29e06,     0x0, 0x270ae,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED80 */	    0x0, 0x2176c,     0x0,     0x0, 0x294d0, 0x26335, 0x27164,     0x0,
/* ED88 */	0x20d28, 0x26d22, 0x24ae2, 0x20d71,     0x0,     0x0, 0x21f0f,     0x0,
/* ED90 */	    0x0, 0x21dd1,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* ED98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x2493e,     0x0,
/* EDA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x2176d,     0x0,
/* EDC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28e97,
/* EDD0 */	    0x0, 0x26d23,     0x0,     0x0,     0x0,     0x0,     0x0, 0x203fc,
/* EDD8 */	    0x0,     0x0, 0x25c21, 0x23cfd,     0x0, 0x24919,     0x0,     0x0,
/* EDE0 */	    0x0, 0x20cd4,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDE8 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x201f2,     0x0,     0x0,
/* EDF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EDF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE00 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE08 */	0x2a64a,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE10 */	    0x0, 0x2837d,     0x0,     0x0,     0x0, 0x24a77,     0x0,     0x0,
/* EE18 */	    0x0,     0x0,     0x0, 0x28a5a,     0x0,     0x0,     0x0,     0x0,
/* EE20 */	0x2a2b2,     0x0, 0x2f840,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE28 */	    0x0,     0x0, 0x24abb,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE30 */	0x2183b, 0x26e05,     0x0,     0x0, 0x2251b,     0x0,     0x0,     0x0,
/* EE38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE48 */	0x26159,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x233f5,     0x0,
/* EE58 */	    0x0,     0x0,     0x0, 0x28bc2,     0x0, 0x28e39,     0x0,     0x0,
/* EE60 */	0x21d46,     0x0,     0x0,     0x0, 0x20f3b,     0x0,     0x0,     0x0,
/* EE68 */	    0x0,     0x0, 0x25f1a,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x27486,     0x0,
/* EE78 */	    0x0,     0x0,     0x0,     0x0, 0x267cc,     0x0, 0x26ed1,     0x0,
/* EE80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE90 */	    0x0, 0x24011,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EE98 */	    0x0,     0x0,     0x0,     0x0, 0x28b2d,     0x0,     0x0,     0x0,
/* EEA0 */	    0x0,     0x0, 0x23cc7, 0x25ed7, 0x27656, 0x25531, 0x21944, 0x212fe,
/* EEA8 */	0x29903, 0x26ddc, 0x270ad,     0x0, 0x261ad, 0x28a0f, 0x23677, 0x200ee,
/* EEB0 */	0x26846, 0x24f0e,     0x0,     0x0, 0x2634c,     0x0,     0x0, 0x2626b,
/* EEB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EED0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EED8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EEF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF00 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF08 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF10 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF18 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF20 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF28 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF30 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF38 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF40 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF48 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF50 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF58 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF60 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF68 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF70 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF78 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF80 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF88 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF90 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EF98 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFA0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFA8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFB0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFB8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFC0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFC8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFD0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFD8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFE0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFE8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFF0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* EFF8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F000 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F008 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F010 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F018 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F020 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F028 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F030 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F038 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F040 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F048 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F050 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F058 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F060 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F068 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F070 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F078 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F080 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F088 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F090 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F098 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F0F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F100 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F108 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F110 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F118 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F120 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F128 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F130 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F138 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F140 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F148 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F150 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F158 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F160 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F168 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F170 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F178 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F180 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F188 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F190 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F198 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F1F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F200 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F208 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F210 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F218 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F220 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F228 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F230 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F238 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F240 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F248 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F250 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F258 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F260 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F268 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F270 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F278 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F280 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F288 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F290 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F298 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F2F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F300 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F308 */	0x2010c,     0x0, 0x200d1, 0x200cd,     0x0,     0x0, 0x200cb, 0x21fe8,
/* F310 */	    0x0, 0x200ca,     0x0,     0x0,     0x0,     0x0, 0x2010e,     0x0,
/* F318 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F320 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F328 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F330 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F338 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F340 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F348 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F350 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F358 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F360 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F368 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F370 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F378 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F380 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F388 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F390 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F398 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3A0 */	0x2a3a9, 0x21145,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3A8 */	    0x0,     0x0,     0x0,     0x0, 0x27735,     0x0,     0x0,     0x0,
/* F3B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3F0 */	0x209e7,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F3F8 */	    0x0, 0x29df6, 0x2700e,     0x0, 0x2a133,     0x0,     0x0,     0x0,
/* F400 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F408 */	0x2846c, 0x21dca, 0x205d0, 0x22ae6,     0x0,     0x0,     0x0,     0x0,
/* F410 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F418 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F420 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F428 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F430 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F438 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x27d84,     0x0,     0x0,
/* F440 */	0x20c42, 0x20d15, 0x2512b,     0x0, 0x22cc6,     0x0, 0x20341,     0x0,
/* F448 */	0x24db8, 0x294e5,     0x0, 0x280be,     0x0, 0x22c38,     0x0,     0x0,
/* F450 */	0x2815d, 0x269f2, 0x24dea,     0x0, 0x20d7c, 0x20fb4, 0x20cd5, 0x210f4,
/* F458 */	    0x0,     0x0, 0x20e96, 0x20c0b, 0x20f64, 0x22ca9, 0x28256, 0x244d3,
/* F460 */	    0x0, 0x20d46, 0x29a4d, 0x280e9,     0x0, 0x24ea7, 0x22cc2,     0x0,
/* F468 */	    0x0, 0x295f4,     0x0,     0x0, 0x252c7, 0x297d4, 0x278c8, 0x22d44,
/* F470 */	    0x0,     0x0,     0x0,     0x0, 0x260a5,     0x0,     0x0, 0x22d4c,
/* F478 */	0x22bca, 0x21077,     0x0, 0x2106f, 0x266da, 0x26716, 0x279a0,     0x0,
/* F480 */	0x25052, 0x20c43,     0x0, 0x221a1, 0x28b4c, 0x20731,     0x0,     0x0,
/* F488 */	0x201a9,     0x0,     0x0, 0x22d8d,     0x0, 0x245c8, 0x204fc, 0x26097,
/* F490 */	0x20f4c, 0x20d96,     0x0,     0x0,     0x0,     0x0,     0x0, 0x22a66,
/* F498 */	0x2109d,     0x0,     0x0, 0x20d9c,     0x0,     0x0, 0x22775,     0x0,
/* F4A0 */	    0x0,     0x0,     0x0,     0x0, 0x2a601, 0x20e09, 0x22acf, 0x22cc9,
/* F4A8 */	    0x0, 0x210c8, 0x239c2,     0x0,     0x0, 0x2829b,     0x0, 0x25e49,
/* F4B0 */	0x220c7,     0x0, 0x20f31, 0x22cb2, 0x29720,     0x0,     0x0, 0x24e3b,
/* F4B8 */	    0x0,     0x0, 0x27574, 0x22e8b, 0x22208, 0x2a65b, 0x28ccd, 0x20e7a,
/* F4C0 */	0x20c34, 0x2681c,     0x0, 0x210cf, 0x22803, 0x22939,     0x0, 0x251e3,
/* F4C8 */	0x20e8c, 0x20f8d, 0x20eaa,     0x0, 0x20f30, 0x20d47, 0x2114f, 0x20e4c,
/* F4D0 */	    0x0, 0x20eab, 0x20ba9, 0x20d48, 0x210c0, 0x2113d,     0x0, 0x22696,
/* F4D8 */	    0x0, 0x20fad, 0x233f4, 0x27639, 0x22bce, 0x20d7e, 0x20d7f, 0x22c51,
/* F4E0 */	0x22c55,     0x0, 0x20e98, 0x210c7, 0x20f2e, 0x2a632, 0x26b50, 0x28cd2,
/* F4E8 */	0x28d99, 0x28cca,     0x0,     0x0,     0x0,     0x0,     0x0, 0x29ec3,
/* F4F0 */	    0x0,     0x0, 0x2775e, 0x22dee,     0x0,     0x0,     0x0,     0x0,
/* F4F8 */	0x26572,     0x0,     0x0,     0x0, 0x280bd,     0x0, 0x20efa, 0x20e0f,
/* F500 */	0x20e77, 0x20efb,     0x0, 0x24deb,     0x0, 0x20cd6,     0x0, 0x227b5,
/* F508 */	0x210c9, 0x20e10, 0x20e78, 0x21078, 0x21148, 0x28207, 0x21455, 0x20e79,
/* F510 */	0x24e50, 0x22da4,     0x0, 0x2101d, 0x2101e, 0x210f5, 0x210f6,     0x0,
/* F518 */	0x20e11, 0x27694, 0x282cd, 0x20fb5, 0x20e7b, 0x2517e,     0x0, 0x20fb6,
/* F520 */	0x21180, 0x252d8, 0x2a2bd, 0x249da, 0x2183a, 0x24177, 0x2827c,     0x0,
/* F528 */	    0x0,     0x0, 0x2573d,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F530 */	    0x0,     0x0,     0x0, 0x25b74, 0x2313d,     0x0,     0x0,     0x0,
/* F538 */	    0x0,     0x0, 0x21bc1, 0x2f878,     0x0, 0x20086,     0x0,     0x0,
/* F540 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F548 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x248e9,     0x0,
/* F550 */	    0x0,     0x0,     0x0, 0x2626a,     0x0,     0x0, 0x2634b,     0x0,
/* F558 */	    0x0, 0x26612, 0x26951,     0x0,     0x0,     0x0, 0x278b2,     0x0,
/* F560 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x28e0f,     0x0,     0x0,
/* F568 */	    0x0,     0x0,     0x0, 0x29810,     0x0,     0x0,     0x0,     0x0,
/* F570 */	    0x0,     0x0, 0x20087,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F578 */	    0x0, 0x29c73,     0x0,     0x0,     0x0, 0x2414e,     0x0,     0x0,
/* F580 */	    0x0, 0x251cd,     0x0, 0x25d30,     0x0, 0x28a32,     0x0,     0x0,
/* F588 */	    0x0,     0x0,     0x0, 0x23281, 0x2a107,     0x0, 0x21980,     0x0,
/* F590 */	    0x0,     0x0,     0x0, 0x2870f,     0x0,     0x0, 0x2a2ba,     0x0,
/* F598 */	    0x0,     0x0,     0x0, 0x29947, 0x28aea,     0x0,     0x0,     0x0,
/* F5A0 */	0x2207e,     0x0,     0x0, 0x289e3,     0x0,     0x0,     0x0,     0x0,
/* F5A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5B0 */	0x21db6,     0x0,     0x0,     0x0, 0x22712,     0x0, 0x233f9,     0x0,
/* F5B8 */	    0x0, 0x23c63,     0x0,     0x0,     0x0, 0x24505,     0x0,     0x0,
/* F5C0 */	0x24a13,     0x0,     0x0,     0x0, 0x25ca4, 0x25695,     0x0,     0x0,
/* F5C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x28db9, 0x2143f,
/* F5D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5E0 */	    0x0,     0x0,     0x0,     0x0, 0x2497b,     0x0, 0x2710d,     0x0,
/* F5E8 */	0x26d74,     0x0, 0x26b15, 0x26fbe,     0x0,     0x0,     0x0,     0x0,
/* F5F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F5F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F600 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F608 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F610 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F618 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F620 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F628 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F630 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F638 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F640 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F648 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F650 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F658 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F660 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F668 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F670 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F678 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F680 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F688 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F690 */	    0x0,     0x0,     0x0,     0x0, 0x289c0,     0x0,     0x0,     0x0,
/* F698 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x23f41,     0x0,
/* F6A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6A8 */	    0x0,     0x0,     0x0,     0x0,     0x0, 0x20325,     0x0,     0x0,
/* F6B0 */	0x20ed8,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F6F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F700 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F708 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F710 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F718 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F720 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F728 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F730 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F738 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F740 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F748 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F750 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F758 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F760 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F768 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F770 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F778 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F780 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F788 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F790 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F798 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0, 0x200cc,     0x0,
/* F7E8 */	0x2008a,     0x0,     0x0,     0x0,     0x0,     0x0, 0x27607,     0x0,
/* F7F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F7F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F800 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F808 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F810 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F818 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F820 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F828 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F830 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F838 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F840 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F848 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F850 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F858 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F860 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F868 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F870 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F878 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F880 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F888 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F890 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F898 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8A0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8A8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8B0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8B8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8C0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8C8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8D0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8D8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8E0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8E8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8F0 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,
/* F8F8 */	    0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0,     0x0
};

